package org.zeroturnaround.javarebel.integration.spring.cbp;

import org.zeroturnaround.bundled.javassist.CtNewMethod;

import org.zeroturnaround.bundled.javassist.CtMethod;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;

import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

public class PropertyResourceConfigurerCBP extends
    JavassistClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass)
      throws Exception {
    
    CtMethod origMethod = ctClass.getDeclaredMethod("postProcessBeanFactory");
    CtMethod copyMethod = CtNewMethod.copy(origMethod, "_postProcessBeanFactory", ctClass, null);
    ctClass.addMethod(copyMethod);
    origMethod.setBody(
        "{" +
          "org.zeroturnaround.javarebel.integration.spring.PropertyResourceConfigurerManager.register($0, $1); " +
          "_postProcessBeanFactory($1);" +
    		"}");
  }
}
